; d0=card
; d1=pos
drawcard89:
        movem.l d0-d7/a0-a6,-(a7)

        divu.w #30,d1
        move.l d1,d2
        and.l #$ffff,d2
        mulu.w #30,d2
        lsr.l #8,d1
        lsr.l #8,d1
        sub.l #1,d1
        lsr.l #2,d1
        mulu.w #22,d1
        add.l #2,d1
        move.l d1,d89col
        ; d2=row addr, d89col=col

        bsr getsuitnum

        cmp.l #4,d1
        beq specialcard89

        move.l gplane1,a0
        bsr drawframe89
        bsr drawnum89
        bsr drawsuit89

        move.l gplane0,a0
        bsr drawframe89

        cmp.l #2,d1
        blt drawdone89

        bsr drawcopyplane89
        bra drawdone89

specialcard89:
        cmp.l #1,d0
        bgt drawempty89

        move.l gplane1,a0
        bsr drawframe89
        move.l gplane0,a0
        bsr drawframe89

        move.l gplane1,a0
        move.l gplane0,a1
        move.l #suitbits,a2
        add.l #112,a2
        add.l d2,a0
        add.l d2,a1
        add.l #30,a0
        add.l #30,a1
        bsr addcola0
        bsr addcola1
        move.l #20,d3
        move.l gplane1,a3      ;LCD_MEM
        add.l #STATUS_LINE_OFS,a3
backloop89:
        clr.l d4
        move.b (a2),d4
        lsl.l #8,d4
        move.b 2(a2),d4
        lsl.l #8,d4
        move.b 4(a2),d4
        and.b #$f0,d4
        lsl.l d6,d4
        or.b d4,3(a0)
        lsr.l #8,d4
        or.b d4,2(a0)
        lsr.l #8,d4
        or.b d4,1(a0)
        lsr.l #8,d4
        or.b d4,(a0)
        clr.l d4
        move.b 1(a2),d4
        lsl.l #8,d4
        move.b 3(a2),d4
        lsl.l #8,d4
        move.b 5(a2),d4
        and.b #$f0,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)
        add.l #6,a2
        add.l #30,a0
        add.l #30,a1
        cmp.l a3,a0
        bge drawdone89
        cmp.b #0,(a2)
        bne backloopnext89
        move.l #suitbits,a2
        add.l #112,a2
backloopnext89:
        dbra d3,backloop89

        bra drawdone89

; Returns shift count in d5, 8-d5 in d6
addcola0:
        move.l d89col(pc),d4
        move.l d4,d5
        lsr.l #3,d4
        and.l #7,d5
        tst.l d5
        bne addcola0finish
        move.l #8,d5
        sub.l #1,d4
addcola0finish:
        add.l d4,a0
        move.l #8,d6
        sub.l d5,d6
        rts

; Returns shift count in d5, 8-d5 in d6
addcola1:
        move.l d89col(pc),d4
        move.l d4,d5
        lsr.l #3,d4
        and.l #7,d5
        tst.l d5
        bne addcola1finish
        move.l #8,d5
        sub.l #1,d4
addcola1finish:
        add.l d4,a1
        move.l #8,d6
        sub.l d5,d6
        rts

; Returns shift count in d5, 8-d5 in d6
addcola2:
        move.l d89col(pc),d4
        move.l d4,d5
        lsr.l #3,d4
        and.l #7,d5
        tst.l d5
        bne addcola2finish
        move.l #8,d5
        sub.l #1,d4
addcola2finish:
        add.l d4,a2
        move.l #8,d6
        sub.l d5,d6
        rts

drawempty89:
        move.l gplane1,a0
        move.l gplane0,a1
        add.l d2,a0
        add.l d2,a1
        bsr addcola0
        bsr addcola1
        move.l #10,d3
        move.l gplane1,a3       ;LCD_MEM
        add.l #STATUS_LINE_OFS,a3
drawemptyloop89:
        move.l #$ff00000f,d4
        rol.l d6,d4
        and.b d4,3(a1)
        and.b d4,3(a0)
        lsr.l #8,d4
        and.b d4,2(a1)
        and.b d4,2(a0)
        lsr.l #8,d4
        and.b d4,1(a1)
        and.b d4,1(a0)
        lsr.l #8,d4
        and.b d4,(a1)
        and.b d4,(a0)
        move.l #$00aaaaa0,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)
        add.l #30,a1
        add.l #30,a0
        cmp.l a3,a0
        bge drawdone89
        move.l #$ff00000f,d4
        rol.l d6,d4
        and.b d4,3(a1)
        and.b d4,3(a0)
        lsr.l #8,d4
        and.b d4,2(a1)
        and.b d4,2(a0)
        lsr.l #8,d4
        and.b d4,1(a1)
        and.b d4,1(a0)
        lsr.l #8,d4
        and.b d4,(a1)
        and.b d4,(a0)
        move.l #$00555550,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)
        add.l #30,a1
        add.l #30,a0
        cmp.l a3,a0
        bge drawdone89
        dbra d3,drawemptyloop89

        move.l #$ff00000f,d4
        rol.l d6,d4
        and.b d4,3(a1)
        and.b d4,3(a0)
        lsr.l #8,d4
        and.b d4,2(a1)
        and.b d4,2(a0)
        lsr.l #8,d4
        and.b d4,1(a1)
        and.b d4,1(a0)
        lsr.l #8,d4
        and.b d4,(a1)
        and.b d4,(a0)
        move.l #$00aaaaa0,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)
        add.l #30,a1
        add.l #30,a0

        cmp.l #3,d0
        bne drawdone89

        move.l d2,d3
        divu.w #30,d3
        and.l #$ffff,d3
        move.l d89col(pc),d4

        move.w #2,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7

        move.w #$00ff,-(a7)
        move.w #$0000,-(a7)
        move.w #$00ff,-(a7)
        move.w #4,-(a7)
        move.w d3,-(a7)
        add.w #7,(a7)
        move.w d4,-(a7)
        add.w #7,(a7)
        move.w #'X',-(a7)
        jsr tios::DrawCharXY
        add.l #14,a7

drawdone89:
        movem.l (a7)+,d0-d7/a0-a6
        rts


drawframe89:
        move.l a0,d7
        add.l #STATUS_LINE_OFS,d7

        move.l a0,a1
        add.l d2,a1

        bsr addcola1

        move.l #$00fffff0,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)

        add.l #30,a1
        cmp.l d7,a1
        bge drawframedone89

        move.l #20,d3
drawframeloop89:
        move.l #$ff00000f,d4
        rol.l d6,d4
        and.b d4,3(a1)
        lsr.l #8,d4
        and.b d4,2(a1)
        lsr.l #8,d4
        and.b d4,1(a1)
        lsr.l #8,d4
        and.b d4,(a1)
        move.l #$00800010,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)

        add.l #30,a1
        cmp.l d7,a1
        bge drawframedone89
        dbra d3,drawframeloop89

        move.l #$00fffff0,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)

        add.l #30,a1

drawframedone89:
        rts

drawnum89:
        move.l d2,d3
        divu.w #30,d3
        and.l #$ffff,d3
        move.l d89col(pc),d4

        clr.l tempstr
        move.l #6,d5

        move.b #'A',tempstr

        cmp.l #1,d0
        beq drawnum89_ok
        cmp.l #10,d0
        beq drawnum89_10
        cmp.l #11,d0
        beq drawnum89_J
        cmp.l #12,d0
        beq drawnum89_Q
        cmp.l #13,d0
        beq drawnum89_K

        move.b #'0',tempstr
        add.b d0,tempstr
        bra drawnum89_ok

drawnum89_10:
        move.b #'1',tempstr
        move.l #10,d5
        bra drawnum89_ok

drawnum89_J:
        move.b #'J',tempstr
        bra drawnum89_ok

drawnum89_Q:
        move.b #'Q',tempstr
        bra drawnum89_ok

drawnum89_K:
        move.b #'K',tempstr

drawnum89_ok:
        movem.l d0-d2/a0-a1,-(a7)

        cmp.l #LCD_HEIGHT-9,d3
        bge drawnumdone89

        movem.l d0-d5,-(a7)

        move.w #1,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7

        movem.l (a7),d0-d5

        move.w #2,-(a7)
        move.l #tempstr,-(a7)
        move.w d3,-(a7)
        add.w #2,(a7)
        move.w d4,-(a7)
        cmp.l #10,d0
        beq drawnum89_noadd1
        add.w #1,(a7)
drawnum89_noadd1:
        jsr tios::DrawStrXY
        add.l #10,a7

        movem.l (a7),d0-d5

        cmp.l #10,d0
        bne drawnum89_not10

        move.b #'0',tempstr
        move.w #4,-(a7)
        move.l #tempstr,-(a7)
        move.w d3,-(a7)
        add.w #2,(a7)
        move.w d4,-(a7)
        add.w #4,(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.b #'1',tempstr

        movem.l (a7),d0-d5

        move.l gplane1,a1
        add.l d2,a1
        bsr addcola1
        add.l #240,a1
        move.l #$ffdfffff,d4
        rol.l d6,d4
        lsr.l #8,d4
        lsr.l #8,d4
        and.b d4,1(a1)
        lsr.l #8,d4
        and.b d4,(a1)

        movem.l (a7),d0-d5

drawnum89_not10:

        cmp.l #LCD_HEIGHT-21,d3
        bge drawnumdone89

        move.w #4,-(a7)
        move.l #tempstr,-(a7)
        move.w d3,-(a7)
        add.w #14,(a7)
        move.w d4,-(a7)
        add.w #18,(a7)
        sub.w d5,(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        movem.l (a7),d0-d5

        cmp.l #10,d0
        bne drawnumdone89

        move.b #'0',tempstr
        move.w #4,-(a7)
        move.l #tempstr,-(a7)
        move.w d3,-(a7)
        add.w #14,(a7)
        move.w d4,-(a7)
        add.w #12,(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        movem.l (a7),d0-d5

        move.l gplane1,a1
        add.l d2,a1
        bsr addcola1
        add.l #600,a1
        move.l #$ffffdfff,d4
        rol.l d6,d4
        lsr.l #8,d4
        and.b d4,2(a1)
        lsr.l #8,d4
        and.b d4,1(a1)
        lsr.l #8,d4
        and.b d4,(a1)

drawnumdone89:
        movem.l (a7)+,d0-d5
        movem.l (a7)+,d0-d2/a0-a1
        rts

drawsuit89:
        move.l a0,d7
        add.l #STATUS_LINE_OFS,d7

        move.l a0,a1
        add.l d2,a1
        bsr addcola1
        add.l #60,a1
        cmp.l d7,a1
        bge drawsuitdone189
        move.l #suitbits,a2
        move.l d1,d3
        mulu.w #28,d3
        add.l d3,a2
        move.l #6,d3
drawsuitloop189:
        clr.l d4
        move.b (a2)+,d4
        lsl.l #8,d4
        move.b (a2)+,d4
        lsl.l #4,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)
        add.l #30,a1
        cmp.l d7,a1
        bge drawsuitdone189
        dbra d3,drawsuitloop189

drawsuitdone189:
        move.l a0,a1
        add.l d2,a1
        bsr addcola1
        add.l #420,a1
        cmp.l d7,a1
        bge drawsuitdone289
        move.l #6,d3
drawsuitloop289:
        clr.l d4
        move.b (a2)+,d4
        lsl.l #8,d4
        move.b (a2)+,d4
        lsl.l #8,d4
        lsl.l d6,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)
        add.l #30,a1
        cmp.l d7,a1
        bge drawsuitdone289
        dbra d3,drawsuitloop289

drawsuitdone289:
        rts

drawcopyplane89:
        move.l a0,d7
        add.l #STATUS_LINE_OFS,d7

        move.l a0,a1
        move.l gplane1,a2
        add.l d2,a1
        add.l d2,a2
        bsr addcola1
        bsr addcola2
        move.l #22,d3
drawcopyloop89:
        move.l #$ff00000f,d4
        rol.l d6,d4
        move.l d4,d5
        and.b d4,3(a1)
        lsr.l #8,d4
        and.b d4,2(a1)
        lsr.l #8,d4
        and.b d4,1(a1)
        lsr.l #8,d4
        and.b d4,(a1)
        clr.l d4
        move.b (a2)+,d4
        lsl.l #8,d4
        move.b (a2)+,d4
        lsl.l #8,d4
        move.b (a2)+,d4
        lsl.l #8,d4
        move.b (a2)+,d4
        not.l d5
        and.l d5,d4
        or.b d4,3(a1)
        lsr.l #8,d4
        or.b d4,2(a1)
        lsr.l #8,d4
        or.b d4,1(a1)
        lsr.l #8,d4
        or.b d4,(a1)
        add.l #30,a1
        add.l #26,a2
        cmp.l d7,a1
        bge drawcopydone89
        dbra d3,drawcopyloop89
drawcopydone89:
        rts

d89col dc.l 0
